--**** A P P L I C A T I O N   N O T E *************************************
--*
--* Title:               AVR-FPGA Interface Design #4
--* Version:             1.1
--* Last Updated:        October 8, 2001
--* Target:              AT94K05/10/40
--*
--* Support Hotline:     +1 (408) 436-4119
--* Support Email:       fpslic@atmel.com
--*
--**************************************************************************

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_unsigned.all;


entity COUNTER2 is
    port (
            CLOCK   : in    std_logic;
            RESET   : in    std_logic;
            ENABLE  : in    std_logic;
            LOAD    : in    std_logic;
            aWE     : in    std_logic;
            D       : in    std_logic_vector(7 downto 0);
            Q       :   out std_logic_vector(7 downto 0);
            RCO     :   out std_logic
         );
end COUNTER2;


architecture BEHAV of COUNTER2 is
begin

    process (CLOCK, RESET, ENABLE, LOAD, D)
        variable QINT : std_logic_vector(7 downto 0);
        variable rRCO : std_logic;
    begin
        if RESET = '1' then
            QINT := "00000000";                         -- Initialize QINT = $00
            rRCO := '1';                                -- Initialize rRCO = $01
        else
            if CLOCK'event and CLOCK = '1' then
                if ENABLE = '1' then
                    if (LOAD = '1' and aWE = '1') then
                        QINT := D;                      -- Assign D to QINT
                    else
                        if QINT /= "00011111" then
                            QINT := QINT + '1';         -- Increment QINT by $01
                            rRCO := '1';                -- Assign rRCO = $01
                        else                            
                            rRCO := '0';                -- Assign rRCO = $00
                        end if;
                    end if;
                end if;
            end if;
        end if;
        
        Q   <= QINT;
        RCO <= rRCO;
        
    end process;
    
end BEHAV;

                       
